clan::TextureProvider Class Reference - ClanLib SDK
Description: clan::TextureProvider Class Reference

Public Member Functions | List of all members
clan::TextureProvider Class Referenceabstract
clanDisplay Display

Interface for implementing a Texture target. More...

`#include <texture_provider.h>`

## Public Member Functions
virtual | ~TextureProvider ()
virtual void | copy_from (GraphicContext &gc, int x, int y, int slice, int level, const PixelBuffer &src, const Rect &src_rect)=0
| Copy image data to texture.
virtual void | copy_image_from (int x, int y, int width, int height, int level, TextureFormat texture_format, GraphicContextProvider *gc)=0
| Copy image data from a graphic context.
virtual void | copy_subimage_from (int offset_x, int offset_y, int x, int y, int width, int height, int level, GraphicContextProvider *gc)=0
| Copy sub image data from a graphic context.
virtual void | create (int width, int height, int depth, int array_size, TextureFormat texture_format, int levels)=0
| Create texture.
virtual std::unique_ptr< TextureProvider > | create_view (TextureDimensions texture_dimensions, TextureFormat texture_format, int min_level, int num_levels, int min_layer, int num_layers)=0
| \breif Creates a texture view for this texture
virtual void | generate_mipmap ()=0
| Generate the mipmap.
virtual PixelBuffer | get_pixeldata (GraphicContext &gc, TextureFormat texture_format, int level) const =0
| Retrieve image data from texture.
virtual void | set_base_level (int base_level)=0
| Sets the texture base level texture parameter.
virtual void | set_lod_bias (double lod_bias)=0
| Sets the level of detail bias constant.
virtual void | set_mag_filter (TextureFilter filter)=0
| Set the magnification filter.
virtual void | set_max_anisotropy (float v)=0
| Set the maximum degree of anisotropy.
virtual void | set_max_level (int max_level)=0
| Sets the texture max level texture parameter.
virtual void | set_max_lod (double max_lod)=0
| Set the maximum level of detail texture parameter.
virtual void | set_min_filter (TextureFilter filter)=0
| Set the minification filter.
virtual void | set_min_lod (double min_lod)=0
| Set the minimum level of detail texture parameter.
virtual void | set_texture_compare (TextureCompareMode mode, CompareFunction func)=0
| Sets the texture compare mode and compare function texture parameters.
virtual void | set_wrap_mode (TextureWrapMode wrap_s)=0
virtual void | set_wrap_mode (TextureWrapMode wrap_s, TextureWrapMode wrap_t)=0
virtual void | set_wrap_mode (TextureWrapMode wrap_s, TextureWrapMode wrap_t, TextureWrapMode wrap_r)=0
| Set the texture wrapping mode.

## Detailed Description

Interface for implementing a Texture target.

## Constructor & Destructor Documentation

## ◆ ~TextureProvider()

virtual clan::TextureProvider::~TextureProvider | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ copy_from()

virtual void clan::TextureProvider::copy_from | ( | GraphicContext & | gc,
|  | int | x,
|  | int | y,
|  | int | slice,
|  | int | level,
|  | const PixelBuffer & | src,
|  | const Rect & | src_rect )
| pure virtual

Copy image data to texture.

References clan::x, and clan::y.

## ◆ copy_image_from()

virtual void clan::TextureProvider::copy_image_from | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | level,
|  | TextureFormat | texture_format,
|  | GraphicContextProvider * | gc )
| pure virtual

Copy image data from a graphic context.

References clan::x, and clan::y.

## ◆ copy_subimage_from()

virtual void clan::TextureProvider::copy_subimage_from | ( | int | offset_x,
|  | int | offset_y,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | level,
|  | GraphicContextProvider * | gc )
| pure virtual

Copy sub image data from a graphic context.

References clan::x, and clan::y.

## ◆ create()

virtual void clan::TextureProvider::create | ( | int | width,
|  | int | height,
|  | int | depth,
|  | int | array_size,
|  | TextureFormat | texture_format,
|  | int | levels )
| pure virtual

Create texture.

## ◆ create_view()

virtual std::unique_ptr< TextureProvider > clan::TextureProvider::create_view | ( | TextureDimensions | texture_dimensions,
|  | TextureFormat | texture_format,
|  | int | min_level,
|  | int | num_levels,
|  | int | min_layer,
|  | int | num_layers )
| pure virtual

\breif Creates a texture view for this texture

## ◆ generate_mipmap()

virtual void clan::TextureProvider::generate_mipmap | ( |  | ) |
| pure virtual

Generate the mipmap.

## ◆ get_pixeldata()

virtual PixelBuffer clan::TextureProvider::get_pixeldata | ( | GraphicContext & | gc,
|  | TextureFormat | texture_format,
|  | int | level ) const
| pure virtual

Retrieve image data from texture.

## ◆ set_base_level()

virtual void clan::TextureProvider::set_base_level | ( | int | base_level | ) |
| pure virtual

Sets the texture base level texture parameter.

## ◆ set_lod_bias()

virtual void clan::TextureProvider::set_lod_bias | ( | double | lod_bias | ) |
| pure virtual

Sets the level of detail bias constant.

## ◆ set_mag_filter()

virtual void clan::TextureProvider::set_mag_filter | ( | TextureFilter | filter | ) |
| pure virtual

Set the magnification filter.

## ◆ set_max_anisotropy()

virtual void clan::TextureProvider::set_max_anisotropy | ( | float | v | ) |
| pure virtual

Set the maximum degree of anisotropy.

References clan::v.

## ◆ set_max_level()

virtual void clan::TextureProvider::set_max_level | ( | int | max_level | ) |
| pure virtual

Sets the texture max level texture parameter.

## ◆ set_max_lod()

virtual void clan::TextureProvider::set_max_lod | ( | double | max_lod | ) |
| pure virtual

Set the maximum level of detail texture parameter.

## ◆ set_min_filter()

virtual void clan::TextureProvider::set_min_filter | ( | TextureFilter | filter | ) |
| pure virtual

Set the minification filter.

## ◆ set_min_lod()

virtual void clan::TextureProvider::set_min_lod | ( | double | min_lod | ) |
| pure virtual

Set the minimum level of detail texture parameter.

## ◆ set_texture_compare()

virtual void clan::TextureProvider::set_texture_compare | ( | TextureCompareMode | mode,
|  | CompareFunction | func )
| pure virtual

Sets the texture compare mode and compare function texture parameters.

## ◆ set_wrap_mode() [1/3]

virtual void clan::TextureProvider::set_wrap_mode | ( | TextureWrapMode | wrap_s | ) |
| pure virtual

## ◆ set_wrap_mode() [2/3]

virtual void clan::TextureProvider::set_wrap_mode | ( | TextureWrapMode | wrap_s,
|  | TextureWrapMode | wrap_t )
| pure virtual

## ◆ set_wrap_mode() [3/3]

virtual void clan::TextureProvider::set_wrap_mode | ( | TextureWrapMode | wrap_s,
|  | TextureWrapMode | wrap_t,
|  | TextureWrapMode | wrap_r )
| pure virtual

Set the texture wrapping mode.

The documentation for this class was generated from the following file:

- texture_provider.h